config/routes.rb
Rails.application.routes.draw do
  resources :measurements

  resources :quantities, except: [:show], path_names: {new: '(/:id)/new'} do
    member { post :reparent }
  end

  resources :units, except: [:show], path_names: {new: '(/:id)/new'} do
    member { post :rebase }
  end

  namespace :default do
    resources :units, only: [:index, :destroy] do
      member { post :import, :export }
      #collection { post :import_all }
    end
  end

  devise_for :users, path: '', path_names: {registration: 'profile'},
    controllers: {registrations: :registrations}
  resources :users, only: [:index, :show, :update] do
    member { get :disguise }
    collection { get :revert }
  end

  unauthenticated do
    as :user do
      root to: redirect('/sign_in')
    end
  end
  root to: redirect('/units'), as: :user_root

  direct(:source_code) { 'https://gitea.michalczyk.pro/fixin.me/fixin.me' }
  direct(:issue_tracker) { 'https://gitea.michalczyk.pro/fixin.me/fixin.me/issues' }
end

app/models/quantity.rb
class Quantity < ApplicationRecord
  ATTRIBUTES = [:name, :description, :parent_id]

  belongs_to :user, optional: true
  belongs_to :parent, optional: true, class_name: "Quantity"
  has_many :subquantities, ->{ order(:name) }, class_name: "Quantity",
    inverse_of: :parent, dependent: :restrict_with_error

  validate if: ->{ parent.present? } do
    errors.add(:parent, :user_mismatch) unless user_id == parent.user_id
    errors.add(:parent, :self_reference) if id == parent_id
  end
  validate if: ->{ parent.present? }, on: :update do
    errors.add(:parent, :descendant_reference) if ancestor_of?(parent)
  end
  validates :name, presence: true, uniqueness: {scope: [:user_id, :parent_id]},
    length: {maximum: type_for_attribute(:name).limit}
  validates :description, length: {maximum: type_for_attribute(:description).limit}

  # Update `depth`s of progenies after parent change
  after_update if: :depth_previously_changed? do
    quantities = Quantity.arel_table
    selected = Arel::Table.new('selected')

    self.class.connection.update(
      Arel::UpdateManager.new.table(
        Arel::Nodes::JoinSource.new(
          quantities,
          [
            quantities.create_join(
              # TODO: user .with(quanities: user.quantities) once the '?' problem is fixed
              Quantity.with_recursive(selected: [
                quantities.project(quantities[:id], quantities[:depth])
                  .where(quantities[:id].eq(id).and(quantities[:user_id].eq(user.id))),
                quantities.project(quantities[:id], selected[:depth] + 1)
                  .join(selected).on(selected[:id].eq(quantities[:parent_id]))
              ]).select(selected[Arel.star]).from(selected).arel.as('selected'),
              quantities.create_on(quantities[:id].eq(selected[:id]))
            )
          ]
        )
      ).set(quantities[:depth] => selected[:depth]),
      "#{self.class} Update All"
    )
  end

  def parent=(value)
    super
    self[:depth] = parent&.depth&.succ || 0
  end

  def parent_id=(value)
    super
    self[:depth] = parent&.depth&.succ || 0
  end

  def depth=(value)
    raise ActiveRecord::ReadonlyAttributeError
  end

  scope :defaults, ->{ where(user: nil) }

  # Return: ordered [sub]hierarchy
  scope :ordered, ->(root: nil, include_root: true) {
    numbered = Arel::Table.new('numbered')

    self.model.with(numbered: numbered(:parent_id, :name)).with_recursive(arel_table.name => [
      numbered.project(
        numbered[Arel.star],
        numbered.cast(numbered[:child_number], 'BINARY').as('path'),
        numbered.cast(numbered[:name], 'CHAR(512)').as('fullname')
      ).where(numbered[root && include_root ? :id : :parent_id].eq(root)),
      numbered.project(
        numbered[Arel.star],
        arel_table[:path].concat(numbered[:child_number]),
        arel_table[:fullname].concat(Arel::Nodes.build_quoted(' → '))
          .concat(numbered[:name]),
      ).join(arel_table).on(numbered[:parent_id].eq(arel_table[:id]))
    ]).order(arel_table[:path])
  }

  # TODO: extract named functions to custom Arel extension
  # NOTE: once recursive queries allow use of window functions, this scope can
  # be merged with :ordered
  # https://gist.github.com/ProGM/c6df08da14708dcc28b5ca325df37ceb#extending-arel
  scope :numbered, ->(parent_column, order_column) {
    select(
      arel_table[Arel.star],
      Arel::Nodes::NamedFunction.new(
        'LPAD',
        [
          Arel::Nodes::NamedFunction.new('ROW_NUMBER', [])
            .over(Arel::Nodes::Window.new.partition(parent_column).order(order_column)),
          Arel::SelectManager.new.project(
            Arel::Nodes::NamedFunction.new('LENGTH', [Arel.star.count])
          ).from(arel_table),
          Arel::Nodes.build_quoted('0')
        ],
      ).as('child_number')
    )
  }

  def to_s
    name
  end

  def destroyable?
    subquantities.empty?
  end

  def default?
    parent_id.nil?
  end

  # Common ancestors, assuming node is a descendant of itself
  scope :common_ancestors, ->(of) {
    selected = Arel::Table.new('selected')

    # Take unique IDs, so self can be called with parent nodes of collection to
    # get common ancestors of collection _excluding_ nodes in collection.
    uniq_of = of.uniq
    model.with(selected: self).with_recursive(arel_table.name => [
      selected.project(selected[Arel.star]).where(selected[:id].in(uniq_of)),
      selected.project(selected[Arel.star])
        .join(arel_table).on(selected[:id].eq(arel_table[:parent_id]))
    ]).select(arel_table[Arel.star])
      .group(column_names)
      .having(arel_table[:id].count.eq(uniq_of.size))
      .order(arel_table[:depth].desc)
  }

  # Return: successive record in order of appearance; used for partial view reload
  def successive
    quantities = Quantity.arel_table
    Quantity.with(
      quantities: user.quantities.ordered.select(
        quantities[Arel.star],
        Arel::Nodes::NamedFunction.new('LAG', [quantities[:id]]).over.as('lag_id')
      )
    ).where(quantities[:lag_id].eq(id)).first
  end

  def with_progenies
    user.quantities.ordered(root: id).to_a
  end

  def progenies
    user.quantities.ordered(root: id, include_root: false).to_a
  end

  # Return: record with ID `of` with its ancestors, sorted by `depth`
  scope :with_ancestors, ->(of) {
    selected = Arel::Table.new('selected')

    model.with(selected: self).with_recursive(arel_table.name => [
      selected.project(selected[Arel.star]).where(selected[:id].eq(of)),
      selected.project(selected[Arel.star])
        .join(arel_table).on(selected[:id].eq(arel_table[:parent_id]))
    ])
  }

  # Return: ancestors of (possibly destroyed) self
  def ancestors
    user.quantities.with_ancestors(parent_id).order(:depth).to_a
  end

  def ancestor_of?(progeny)
    user.quantities.with_ancestors(progeny.id).exists?(id)
  end

  def self.full_names!(of)
    self['fullname'] ||
      user.quantities.with_ancestors(id).order(:depth).map(&:name).join(' → ')
  end
  scope :with_full_name, ->{
  }
end

app/controllers/quantities_controller.rb
class QuantitiesController < ApplicationController
  before_action only: :new do
    find_quantity if params[:id].present?
  end
  before_action :find_quantity, only: [:edit, :update, :reparent, :destroy]

  before_action except: :index do
    raise AccessForbidden unless current_user.at_least(:active)
  end

  def index
    @quantities = current_user.quantities.ordered.includes(:parent).includes(:subquantities)
  end

  def new
    @quantity = current_user.quantities.new(parent: @quantity)
  end

  def create
    @quantity = current_user.quantities.new(quantity_params)
    if @quantity.save
      @before = @quantity.successive
      @ancestors = @quantity.ancestors
      flash.now[:notice] = t('.success', quantity: @quantity)
    else
      render :new
    end
  end

  def edit
  end

  def update
    if @quantity.update(quantity_params.except(:parent_id))
      @ancestors = @quantity.ancestors
      flash.now[:notice] = t('.success', quantity: @quantity)
    else
      render :edit
    end
  end

  def reparent
    permitted = params.require(:quantity).permit(:parent_id)
    @previous_ancestors = @quantity.ancestors

    # Until UI blocks all disallowed reparents, render error messages if present
    render_no_content(@quantity) unless @quantity.update(permitted)

    @ancestors = @quantity.ancestors
    @self_and_progenies = @quantity.with_progenies
    @before = @self_and_progenies.last.successive
  end

  def destroy
    @quantity.destroy!
    @ancestors = @quantity.ancestors
    flash.now[:notice] = t('.success', quantity: @quantity)
  end

  private

  def quantity_params
    params.require(:quantity).permit(Quantity::ATTRIBUTES)
  end

  def find_quantity
    @quantity = current_user.quantities.find_by!(id: params[:id])
  end
end

app/helpers/quantities_helper.rb
module QuantitiesHelper
end

app/views/quantities/_form.html.erb
<%= tabular_fields_for @quantity, form: form_tag do |form| %>
  <%- tag.tr id: row, class: "form", onkeydown: "processKey(event)",
    data: {link: link, form: form_tag, hidden_row: hidden_row} do %>

    <td style="--depth:<%= @quantity.depth %>">
      <%= form.text_field :name, required: true, autofocus: true, size: 20 %>
    </td>
    <td>
      <%= form.text_area :description, cols: 30, rows: 1, escape: false %>
    </td>

    <td class="actions">
      <%= form.button %>
      <%= image_link_to t(:cancel), "close-outline", quantities_path, class: 'dangerous',
        name: :cancel, onclick: render_turbo_stream('form_close', {row: row}) %>
    </td>
    <td></td>
  <% end %>
<% end %>

app/views/quantities/_form_close.html.erb
<%= turbo_stream.close_form row %>
<%= turbo_stream.update :flashes %>

app/views/quantities/_quantity.html.erb
<%= tag.tr id: dom_id(quantity),
           ondragstart: "dragStart(event)", ondragend: "dragEnd(event)",
           ondragover: "dragOver(event)", ondrop: "drop(event)",
           ondragenter: "dragEnter(event)", ondragleave: "dragLeave(event)",
           data: {drag_path: reparent_quantity_path(quantity), drop_id: dom_id(quantity),
                  drop_id_param: "quantity[parent_id]"} do %>

  <td class="link" style="--depth:<%= quantity.depth %>">
    <%= link_to quantity, edit_quantity_path(quantity), onclick: 'this.blur();',
      data: {turbo_stream: true} %>
  </td>
  <td><%= quantity.description %></td>

  <% if current_user.at_least(:active) %>
    <td class="actions">
      <%= image_link_to t('.new_subquantity'), 'plus-outline', new_quantity_path(quantity),
        id: dom_id(quantity, :new, :link), onclick: 'this.blur();', data: {turbo_stream: true} %>

      <%= image_button_to_if quantity.destroyable?, t('.destroy'), 'delete-outline',
        quantity_path(quantity), method: :delete %>
    </td>
    <td class="handle" draggable="true">&#x283F</td>
  <% end %>
<% end %>

app/views/quantities/create.turbo_stream.erb
<%= turbo_stream.close_form dom_id(@quantity.parent || Quantity, :new) %>
<%= turbo_stream.remove :no_items %>
<% @ancestors.map do |ancestor| %>
  <%= turbo_stream.replace ancestor %>
<% end %>
<%= @before ? turbo_stream.before(@before, @quantity) :
  turbo_stream.append(:quantities, @quantity) %>

app/views/quantities/destroy.turbo_stream.erb
<% @ancestors.map do |ancestor| %>
  <%= turbo_stream.replace ancestor %>
<% end %>
<%= turbo_stream.remove @quantity %>
<%= turbo_stream.append(:quantities, render_no_items) if current_user.quantities.empty? %>

app/views/quantities/edit.turbo_stream.erb
<% ids = {row: dom_id(@quantity, :edit),
          hidden_row: dom_id(@quantity),
          link: nil,
          form_tag: dom_id(@quantity, :edit, :form)} %>

<%= turbo_stream.append :quantity_form do %>
  <%- tabular_form_with model: @quantity, html: {id: ids[:form_tag]} do %>
  <% end %>
<% end %>

<%= turbo_stream.hide ids[:hidden_row] %>
<%= turbo_stream.remove ids[:row] %>
<%= turbo_stream.after @quantity, partial: 'form', locals: ids -%>

app/views/quantities/index.html.erb
<div class="rightside buttongrid">
  <% if current_user.at_least(:active) %>
    <%= image_link_to t('.new_quantity'), 'plus-outline', new_quantity_path,
      id: dom_id(Quantity, :new, :link), onclick: 'this.blur();', data: {turbo_stream: true} %>
  <% end %>
  <%#= image_link_to t('.import_quantities'), 'download-outline', default_quantities_path,
    class: 'tools' %>
</div>

<%= tag.div class: 'main', id: :quantity_form %>

<table class="main items">
  <thead>
    <tr>
      <th><%= Quantity.human_attribute_name(:name).capitalize %></th>
      <th><%= Quantity.human_attribute_name(:description).capitalize %></th>
      <% if current_user.at_least(:active) %>
        <th><%= t :actions %></th>
        <th></th>
      <% end %>
    </tr>
    <%= tag.tr id: "quantity_", hidden: true,
               ondragover: "dragOver(event)", ondrop: "drop(event)",
               ondragenter: "dragEnter(event)", ondragleave: "dragLeave(event)",
               data: {drop_id: "quantity_", drop_id_param: "quantity[parent_id]"} do %>
      <th colspan="4"><%= t '.top_level_drop' %></th>
    <% end %>
  </thead>
  <tbody id="quantities">
    <%= render(@quantities) || render_no_items %>
  </tbody>
</table>

app/views/quantities/new.turbo_stream.erb
<% dom_obj = @quantity.parent || @quantity %>
<% ids = {row: dom_id(dom_obj, :new),
          hidden_row: nil,
          link: dom_id(dom_obj, :new, :link),
          form_tag: dom_id(dom_obj, :new, :form)} %>

<%= turbo_stream.disable ids[:link] -%>

<%= turbo_stream.append :quantity_form do %>
  <%- tabular_form_with model: @quantity, html: {id: ids[:form_tag]} do |form| %>
    <%= form.hidden_field :parent_id if @quantity.parent_id? %>
  <% end %>
<% end %>

<% if @quantity.parent_id? %>
  <%= turbo_stream.remove ids[:row] %>
  <%= turbo_stream.after @quantity.parent, partial: 'form', locals: ids %>
<% else %>
  <%= turbo_stream.prepend :quantities, partial: 'form', locals: ids %>
<% end %>

app/views/quantities/reparent.turbo_stream.erb
<% @self_and_progenies.each do |q| %>
  <%= turbo_stream.remove q %>
<% end %>
<% @previous_ancestors.union(@ancestors).map do |ancestor| %>
  <%= turbo_stream.replace ancestor %>
<% end %>
<% @self_and_progenies.each do |q| %>
  <%= @before ? turbo_stream.before(@before, q) : turbo_stream.append(:quantities, q) %>
<% end %>

app/views/quantities/update.turbo_stream.erb
<%= turbo_stream.close_form dom_id(@quantity, :edit) %>
<% @ancestors.push(@quantity).map do |ancestor| %>
  <%= turbo_stream.replace ancestor %>
<% end %>